; ==========    =========
;
;     PIC16F84A    
; MPLAB6.60       
;    
;
; =================================================================

	include <P16F84A.inc>
	radix dec
	processor 16F84A
	__config _pwrte_on & _wdt_on & _rc_osc

; ------   ---------

indata equ 12
incnt equ indata+1
waitcnt equ incnt+1
del100cnt equ waitcnt+1

; ___ equ delcnt+1

; -------   -----------

	org 0
	goto reset

	org 8

; -------  ----------

;   (indata)  .
Indikation
	movlw 8
	movwf incnt
	bsf porta,3
indik1
	bcf portb,6
	btfsc indata,7
	bsf portb,6
	bsf portb,7
	rlf indata,f
	bcf portb,7
	decfsz incnt,f
	goto indik1
	bcf porta,3
	retlw 0xFF

;     
; (Adm-, Mid-, Imp-)

X1Adm
	bsf status,rp0
	bcf trisb,0
	bsf trisb,1
	bsf trisb,2
	bcf status,rp0
	retlw 0xFF
X1Mid
	bsf status,rp0
	bsf trisb,0
	bcf trisb,1
	bsf trisb,2
	bcf status,rp0
	retlw 0xFF
X1Imp
	bsf status,rp0
	bsf trisb,0
	bsf trisb,1
	bcf trisb,2
	bcf status,rp0
	retlw 0xFF

X2Adm
	bsf status,rp0
	bcf trisb,3
	bsf trisb,4
	bsf trisb,5
	bcf status,rp0
	retlw 0xFF

X2Mid
	bsf status,rp0
	bsf trisb,3
	bcf trisb,4
	bsf trisb,5
	bcf status,rp0
	retlw 0xFF
X2Imp
	bsf status,rp0
	bsf trisb,3
	bsf trisb,4
	bcf trisb,5
	bcf status,rp0
	retlw 0xFF

X3Adm
	bsf status,rp0
	bcf trisa,0
	bsf trisa,1
	bsf trisa,2
	bcf status,rp0
	retlw 0xFF
X3Mid
	bsf status,rp0
	bsf trisa,0
	bcf trisa,1
	bsf trisa,2
	bcf status,rp0
	retlw 0xFF
X3Imp
	bsf status,rp0
	bsf trisa,0
	bsf trisa,1
	bcf trisa,2
	bcf status,rp0
	retlw 0xFF

;    
; (H-, L-)

X1H
	movlw B'00000111'
	iorwf portb,f
	retlw 0xFF
X1L
	movlw B'11111000'
	andwf portb,f
	retlw 0xFF
X2H
	movlw B'00111000'
	iorwf portb,f
	retlw 0xFF
X2L
	movlw B'11000111'
	andwf portb,f
	retlw 0xFF
X3H
	movlw B'00000111'
	iorwf porta,f
	retlw 0xFF
X3L
	movlw B'11111000'
	andwf porta,f
	retlw 0xFF

;     
;  -  : Z=1 - , Z=0 - 

X1
	bsf status,rp0
	movfw trisb
	bcf status,rp0
	andwf portb,w
	andlw B'00000111'
	retlw 0xFF
X2
	bsf status,rp0
	movfw trisb
	bcf status,rp0
	andwf portb,w
	andlw B'00111000'
	retlw 0xFF
X3
	bsf status,rp0
	movfw trisa
	bcf status,rp0
	andwf porta,w
	andlw B'00000111'
	retlw 0xFF

;   .
;  -  W-:     .

Test_NPN_EKB
	call X1Adm	;  -     
	call X1L
	call X2Mid	;  -    
	call X2H
	call X3Imp	;     
	call X3L	;   
	call X2		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X3H	;   
	call X2		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'81'	; , 

Test_PNP_EKB
	call X1Adm	;  -    
	call X1H
	call X2Mid	;  -     
	call X2L
	call X3Imp	;     
	call X3L	;   
	call X2		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X3H	;   
	call X2		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'41'	; , 

Test_NPN_EBK
	call X1Adm	;  -     
	call X1L
	call X3Mid	;  -    
	call X3H
	call X2Imp	;     
	call X2L	;   
	call X3		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X2H	;   
	call X3		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'82'	; , 

Test_PNP_EBK
	call X1Adm	;  -    
	call X1H
	call X3Mid	;  -     
	call X3L
	call X2Imp	;     
	call X2L	;   
	call X3		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X2H	;   
	call X3		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'42'	; , 

Test_NPN_KBE
	call X3Adm	;  -     
	call X3L
	call X1Mid	;  -    
	call X1H
	call X2Imp	;     
	call X2L	;   
	call X1		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X2H	;   
	call X1		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'84'	; , 

Test_PNP_KBE
	call X3Adm	;  -    
	call X3H
	call X1Mid	;  -     
	call X1L
	call X2Imp	;     
	call X2L	;   
	call X1		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X2H	;   
	call X1		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'44'	; , 

Test_NPN_KEB
	call X2Adm	;  -     
	call X2L
	call X1Mid	;  -    
	call X1H
	call X3Imp	;     
	call X3L	;   
	call X1		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X3H	;   
	call X1		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'88'	; , 

Test_PNP_KEB
	call X2Adm	;  -    
	call X2H
	call X1Mid	;  -     
	call X1L
	call X3Imp	;     
	call X3L	;   
	call X1		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X3H	;   
	call X1		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'48'	; , 

Test_NPN_BKE
	call X3Adm	;  -     
	call X3L
	call X2Mid	;  -    
	call X2H
	call X1Imp	;     
	call X1L	;   
	call X2		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X1H	;   
	call X2		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'90'	; , 

Test_PNP_BKE
	call X3Adm	;  -    
	call X3H
	call X2Mid	;  -     
	call X2L
	call X1Imp	;     
	call X1L	;   
	call X2		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X1H	;   
	call X2		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'50'	; , 

Test_NPN_BEK
	call X2Adm	;  -     
	call X2L
	call X3Mid	;  -    
	call X3H
	call X1Imp	;     
	call X1L	;   
	call X3		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X1H	;   
	call X3		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'A0'	; , 

Test_PNP_BEK
	call X2Adm	;  -    
	call X2H
	call X3Mid	;  -     
	call X3L
	call X1Imp	;     
	call X1L	;   
	call X3		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X1H	;   
	call X3		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'60'	; , 

;    1 
Wait
	movlw 9
	movwf waitcnt
wait1
	clrwdt
	decfsz waitcnt,f
	goto wait1
	retlw 0xFF

;  0.1 
del100
	movlw 100
	movwf del100cnt
del100a
	call wait
	decfsz del100cnt,f
	goto del100a
	retlw 0xFF

del300
	call del100
	call del100
	goto del100

;   ()
Mig
	clrf indata		;  
	call Indikation
	bsf portb,6
	movlw 8
	movwf indata
mig1
	bsf portb,7
	bcf portb,7
	call del100
	decfsz indata,f
	goto mig1
	call del300
	bsf porta,3
	call del300
	bcf porta,3
	call del300
	bsf porta,3
	call del300
	bcf porta,3
	call del300
	bsf porta,3
	call del300
	bcf porta,3
	call del300
	bcf portb,6
	movlw 8
	movwf indata
mig2
	bsf portb,7
	bcf portb,7
	call del100
	decfsz indata,f
	goto mig2
	return

; -------   ------
reset

; ------     ------

; 
	clrf porta
	clrf portb
	bsf status,rp0
	clrf trisa
	clrf trisb
	bcf status,rp0
	clrwdt
	call Mig

; ------    -----------------
main

	clrwdt
	clrf indata

	call Test_NPN_EKB
	iorwf indata,f

	call Test_PNP_EKB
	iorwf indata,f

	call Test_NPN_EBK
	iorwf indata,f

	call Test_PNP_EBK
	iorwf indata,f

	call Test_NPN_KBE
	iorwf indata,f

	call Test_PNP_KBE
	iorwf indata,f

	call Test_NPN_KEB
	iorwf indata,f

	call Test_PNP_KEB
	iorwf indata,f

	call Test_NPN_BKE
	iorwf indata,f

	call Test_PNP_BKE
	iorwf indata,f

	call Test_NPN_BEK
	iorwf indata,f

	call Test_PNP_BEK
	iorwf indata,f

	call Indikation
	goto main


; ============  ==============
	end
